<template>
    <div class="w-100">
        <div class="_app_wrapper">
            <div class="detail_box">
                
                <!-- category -->
                    <div class="category" id="category">
                        <div class="title raleway">
                            <h4 class="font-roboto">Types of wires</h4>
                        </div>
                        <ul>
                            <li :class="getSelectedC(value)" v-for="(value, index) in category_list" :key="index" @click="changeCategory(value)">
                                <a class="_scroll" to="#product_wrapper" href="javascript:void(0);">
                                    <div class="img">
                                        <img :src="$store.state.app_domain + value.img" alt="">
                                    </div>
                                    {{ value.name }}
                                </a>
                            </li>
                        </ul>
                    </div>
                <!-- end -->


                <!-- products -->
                
                    <div class="product_wrapper" id="product_wrapper" v-if="showProducts">
                        <div class="title raleway">
                            <h4 class="font-roboto">Size of wires</h4>
                        </div>
                        <div class="product_box_wrapper" v-if="!productLoad">
                            <div class="product_box" v-for="p in products" :key="p.id_product" @click="getAttributes(p.id_product)">
                                <div :class="'basic_info _scroll ' + getSelectedP(p.id_product)" to="#product_actions">
                                    <p class="text-center"> {{ p.name }} </p>
                                    <div class="price-tag">
                                        <p v-if="productDetails.regular_price && productDetails.id_product == p.id_product">
                                            {{ productDetails.regular_price.toLocaleString('en-US', { style: 'currency', currency: 'USD' }) }}
                                        </p>
                                        <p v-else>{{ p.price }}</p>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="product_box_wrapper _progress" v-else>
                            <v-progress-circular
                                :size="70"
                                :width="3"
                                color="#da3327"
                                indeterminate
                            ></v-progress-circular>
                        </div>
                    </div>

                <!-- end -->

                <!-- attributes -->
                    <div class="product_actions" id="product_actions" v-if="showAttributes">
                        <div class="title raleway mt-3">
                            <h4 class="font-roboto">Add to Cart</h4> 
                        </div>
                        <div v-if="!attributeLoad" class="w-100 display-flex align-center justify-center flex-column">
                            <div class="__right" :key="ind" v-for="(comb, ind) in pComb.values" v-if="pComb">
                                <div class="length_title">{{ ind }}</div>
                                    <div class="row">
                                    <div class="col m4" v-for="(cc, i) in comb" :key="i">
                                    <div>
                                        <div @click="changeAttribute(cc)" :class="'length_box  ' +  getSelected(cc)"> {{ cc.value }} </div>
                                    </div>
                                    </div>
                                </div>
                            </div>
                            <div class="__right">
                                <div class="length_title">Bundles</div>
                                <div class="row bundle_boxes">
                                    <div class="marge_box __operator" id="btn_decrease" @click="changeQty(false)">
                                        -
                                    </div>
                                    <div class="marge_box __text-field" id="_quantity_value">
                                        <span v-text="qty"></span>
                                    </div>
                                    <div class="marge_box __operator" id="btn_increase" @click="changeQty(true)">
                                        +
                                    </div>
                                    <div class="_error_msg" id="_error_msg">
                                        The minimum purchase order quantity for the product is 2
                                        <i class="material-icons" id="close_error">
                                            close
                                        </i>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="_progress" v-else>
                             <v-progress-circular
                                :size="70"
                                :width="3"
                                color="#da3327"
                                indeterminate
                            ></v-progress-circular>
                        </div>
                    </div>
                <!-- end -->
                    <v-divider class="mb-3 mt-3" v-if="showAttributes"></v-divider>
                <!-- add to cart btn -->
                    <div class="add_to_cart mb-3" v-if="showAttributes">
                        <v-chip color="red" text-color="white" class="_price_tag">
                            <span v-if="productDetails.regular_price">
                                {{ productDetails.regular_price.toLocaleString('en-US', { style: 'currency', currency: 'USD' }) }}
                            </span>

                            <span>
                                {{ product_grand_price }}
                            </span>

                        </v-chip>
                        <v-btn
                            color="success"
                            large
                            :loading="addProcess"
                            ripple 
                            @click="addToCart"
                        > <v-icon>shopping_cart</v-icon> Add to cart </v-btn>
                        <v-btn
                            color="success"
                            v-if="this.productDetails.product_type == 'Bale'"
                            outline
                            :loading="maxBundleLoad"
                            large
                            @click="maxBundleQtyToCart"
                        > Order 1 full pallets({{ maxQty }} bundles) </v-btn>
                    </div>

                <!-- end -->

            </div>
        </div>
    </div>
</template>
<script>
import  axios from 'axios';
export default {
    layout: 'application',
    data () {
        return {
            context: null,
            category_list: [],
            selectedCategory: [],
            selectedProduct_id: null,
            products: [],
            productDetails: [],
            pComb: [],
            comb_not_found: false,
            qty: 0,
            addProcess: false,
            productLoad: true,
            attributeLoad: true,
            showProducts: false,
            showAttributes: false,
            maxBundleLoad: false,
            maxQty: null,
            product_grand_price: null,
        }
    },asyncData (context) {
        var store = context.store;
        return axios.get (store.state.api_domain + '?comp=process&action=getAppCategory')
        .then((res) => {
            return {
                category_list: res.data.alldata,
                category: res.data.data['url']
            }
        });
    },
    // created() {
    //     axios.get(this.$store.state.api_domain + '?comp=process&action=getAppCategory').then((res) => {
    //         this.category_list = res.data.alldata;
    //         this.category = res.data.data['url'];
    //     });
    // },
    methods: {
        maxBundleQtyToCart: function() {
            this.maxBundleLoad = true;
            this.getMaxQty();
            this.setProductToCart(this.maxQty);
        },
        getSelectedC: function(value) {
            var name = value.name;
            if (this.selectedCategory['name'] == name) {
                return 'active';
            }
            return '';
        },
        changeCategory: function(value) {
            this.showProducts = true;
            this.showAttributes = false;
            this.productLoad = true;
            this.selectedCategory = value;
            this.getCategoryProduct();
        },
        getCategoryProduct: function() {
            var url = this.selectedCategory['url'];
            axios.get(this.$store.state.api_domain + '?comp=category&url=' + url).then((res) => {
                this.products = res.data.category.products;
                var id_product = this.products[0]['id_product'];
                if (id_product) {
                } 
            });
        },
        getSelectedP: function(p) {
             if (this.selectedProduct_id == p) {
                 return 'active';
             } 
             return '';
        },
        getAttributes: function(id_product) {
            axios.get(this.$store.state.api_domain + '?comp=product&id=' + id_product)
            .then((res) => {
                this.showAttributes = true;
                this.productDetails = res.data.product;
                this.pComb = res.data.product.all_combinations;
                this.selectedProduct_id = id_product;
                this.getQty(); //Trigger qty change
                this.getPrice(); //Trigger price change
                this.getMaxQty();
                this.attributeLoad = false;
            });
        },
        changeAttribute : function(cc) {
            var iag = cc.id_attribute_group; //Id attribute group
            var iav = cc.value; //Id Attribute value
            var current_combination = this.productDetails.all_combinations.default_combination_values;
            var ac = this.productDetails.all_combinations.combinations; //All attribute combinations
            this.productDetails.all_combinations.default_combination_values[iag] = cc.value; //Triggered change
            var dc = this.productDetails.all_combinations.default_combination_values;
            this.productDetails.all_combinations.price_impact[cc.value];
            var matches = false;
            for (var comb in ac) {
                for (var d in dc) {
                    if (d && d !== 'undefined') {
                        if (ac[comb][d] != dc[d]) {
                            break;
                        } else {
                            for (var dd in dc) {
                                if (ac[comb][dd] == dc[d]) {
                                    matches = true;
                                } else {
                                    matches = false;
                                }
                            }
                        }
                    }
                }
                if (matches) {
                    this.comb_not_found = false;
                    this.productDetails.id_product_attribute = comb;
                    break;
                } else {
                   this.comb_not_found = true;
                }
            }
            this.getQty(); //Trigger qty change
            this.getPrice(); //Trigger price change
            this.getMaxQty();
        },
        getQty: function() {
            if (this.productDetails.id_product_attribute) {
                this.qty = this.productDetails.all_combinations['minimal'][this.productDetails.id_product_attribute];
            } else {
                this.qty = this.productDetails.minimal_quantity;
            }
            return this.qty;
        },
        getPrice: function() {
            var ipa = this.productDetails.id_product_attribute;
            if (this.productDetails.id_product_attribute) {
                this.productDetails.regular_price = this.cNumber(this.productDetails.all_combinations.price_impact[ipa]);
            } else {
                this.productDetails.regular_price = this.cNumber(this.productDetails.regular_price);
            }

            return this.productDetails.regular_price;
        },
        cNumber: function(val) {
            var p = val.replace(',','');
            return Number(p).toLocaleString('en-US', { style: 'currency', currency: 'USD' })
        },
        getMaxQty() {
            var ipa = this.productDetails.id_product_attribute;
            if (this.productDetails.id_product_attribute) {
                this.maxQty = Number(this.productDetails.all_combinations.max_bundles_per_pallet[ipa]);
            } 
        },
        getSelected: function(cc) {
            var iag = cc.id_attribute_group; //Id attribute group
            var iav = cc.value; //Id Attribute value
            var current_combination = this.productDetails.id_product_attribute;
            var dc = this.productDetails.all_combinations.default_combination_values; //All attribute combinations
            if (dc[iag] == cc.value) {
                return ' active';
            }
            return '';
        },
        getMinimalQty() {
            if (this.productDetails.id_product_attribute) {
                return this.productDetails.all_combinations['minimal'][this.productDetails.id_product_attribute];
            } else {
                return this.productDetails.minimal_quantity;
            }
        },
        changeQty(add) {
            if (add) {
                this.qty = +this.qty + 1;
            } else {
                var qty = this.qty;
                this.qty = +this.qty - 1;
                if (this.qty < this.getMinimalQty()) {
                this.qty = qty;
                }
            }
        },
        addToCart: function() {
            if (this.qty < this.getMinimalQty()) {
                this.$store.commit('showSnackBar', 'Wire quantity should be at least ' + this.getMinimalQty);
                return false;
            }
            this.addProcess = true;
            var qty = this.qty;
            this.setProductToCart(this.qty);
        },
        setProductToCart: function(qty) {
            var form_data = new FormData();
            form_data.append('id_product', this.productDetails.id_product);
            form_data.append('id_product_attribute', this.productDetails.id_product_attribute);
            form_data.append('qty', qty);
            axios.post(this.$store.state.api_domain + '?comp=process&action=addToCart', form_data, {withCredentials: true})
            .then((res) => {
                this.addProcess = false;
                this.maxBundleLoad = false;
                if (res.data.status == 'error') {
                    this.$store.commit('showSnackBar', res.data.message);
                }

                if (res.data.status == 'success') {
                    this.$store.commit('setCart', res.data.message);
                    this.$store.commit('cartDrawer', true);          
                } 
            });
        }
    }
}
</script>
